﻿Imports System
Imports System.IO.Ports

Public Class Form1
    Dim inBuff As Byte()
    Dim buffLen As Integer

    Sub SetSingleRelay(ByRef RelayN As String, ByRef OnOff As Boolean)
        Try
           

        Dim strOnOff
        If OnOff = False Then
            strOnOff = "-//"  'Set the Relay OFF
        Else
            strOnOff = "+//"  'Set the Relay ON
        End If
        SerialPort1.Write(RelayN + strOnOff)
        rtLog.AppendText("Send:" + RelayN + strOnOff + vbCrLf)

        'Reading
        While (SerialPort1.BytesToRead < 4)
        End While
        buffLen = SerialPort1.BytesToRead
        ReDim inBuff(buffLen)

        SerialPort1.Read(inBuff, 0, buffLen)


        rtLog.AppendText("Receive Chars: ")
        For i As Integer = 0 To (buffLen - 1)
            rtLog.AppendText(Chr(inBuff(i)))
        Next

        rtLog.AppendText(", Bytes[dec]:")
        For i As Integer = 0 To (buffLen - 1)
            rtLog.AppendText("[" + Str(Asc(Chr(inBuff(i)))) + "]")
        Next
            rtLog.AppendText(vbCrLf)

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Sub SetAllOnOff(ByRef OnOff As String)
        Try
            SerialPort1.Write(OnOff + "//")
            rtLog.AppendText("Send:" + OnOff + "//" + vbCrLf)

            'Reading
            While (SerialPort1.BytesToRead < 4)
            End While
            buffLen = SerialPort1.BytesToRead
            ReDim inBuff(buffLen)

            SerialPort1.Read(inBuff, 0, buffLen)


            rtLog.AppendText("Receive Chars: ")
            For i As Integer = 0 To (buffLen - 1)
                rtLog.AppendText(Chr(inBuff(i)))
            Next

            rtLog.AppendText(", Bytes[dec]:")
            For i As Integer = 0 To (buffLen - 1)
                rtLog.AppendText("[" + Str(Asc(Chr(inBuff(i)))) + "]")
            Next
            rtLog.AppendText(vbCrLf)

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Sub SetAllRelays()
        Try
            Dim buffer As Byte()
            ReDim buffer(2)


            If cbSetAll1.Checked = True Then buffer(0) = buffer(0) Or 128 Else buffer(0) = buffer(0) And 127
            If cbSetAll2.Checked = True Then buffer(0) = buffer(0) Or 64 Else buffer(0) = buffer(0) And 191
            If cbSetAll3.Checked = True Then buffer(0) = buffer(0) Or 32 Else buffer(0) = buffer(0) And 223
            If cbSetAll4.Checked = True Then buffer(0) = buffer(0) Or 16 Else buffer(0) = buffer(0) And 239
            If cbSetAll5.Checked = True Then buffer(0) = buffer(0) Or 8 Else buffer(0) = buffer(0) And 247
            If cbSetAll6.Checked = True Then buffer(0) = buffer(0) Or 4 Else buffer(0) = buffer(0) And 251
            If cbSetAll7.Checked = True Then buffer(0) = buffer(0) Or 2 Else buffer(0) = buffer(0) And 253
            If cbSetAll8.Checked = True Then buffer(0) = buffer(0) Or 1 Else buffer(0) = buffer(0) And 254


            If cbSetAll9.Checked = True Then buffer(1) = buffer(1) Or 128 Else buffer(1) = buffer(1) And 127
            If cbSetAll10.Checked = True Then buffer(1) = buffer(1) Or 64 Else buffer(1) = buffer(1) And 191
            If cbSetAll11.Checked = True Then buffer(1) = buffer(1) Or 32 Else buffer(1) = buffer(1) And 223
            If cbSetAll12.Checked = True Then buffer(1) = buffer(1) Or 16 Else buffer(1) = buffer(1) And 239
            If cbSetAll13.Checked = True Then buffer(1) = buffer(1) Or 8 Else buffer(1) = buffer(1) And 247
            If cbSetAll14.Checked = True Then buffer(1) = buffer(1) Or 4 Else buffer(1) = buffer(1) And 251
            If cbSetAll15.Checked = True Then buffer(1) = buffer(1) Or 2 Else buffer(1) = buffer(1) And 253
            If cbSetAll16.Checked = True Then buffer(1) = buffer(1) Or 1 Else buffer(1) = buffer(1) And 254

            SerialPort1.Write("x")
            SerialPort1.Write(buffer, 0, 2)
            SerialPort1.Write("//")
            rtLog.AppendText("Send: x" + Chr(buffer(0)) + Chr(buffer(1)) + "//" + vbCrLf)

            'Reading
            While (SerialPort1.BytesToRead < 4)
            End While
            buffLen = SerialPort1.BytesToRead
            ReDim inBuff(buffLen)

            SerialPort1.Read(inBuff, 0, buffLen)

            rtLog.AppendText("Receive Chars: ")
            For i As Integer = 0 To (buffLen - 1)
                rtLog.AppendText(Chr(inBuff(i)))
            Next

            rtLog.AppendText(", Bytes[dec]:")
            For i As Integer = 0 To (buffLen - 1)
                rtLog.AppendText("[" + Str(Asc(Chr(inBuff(i)))) + "]")
            Next
            rtLog.AppendText(vbCrLf)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub GetAllRelays()
        Try
            SerialPort1.Write("ask//")
            rtLog.AppendText("Send: ask//" + vbCrLf)

            'Reading
            While (SerialPort1.BytesToRead < 2)
            End While
            buffLen = SerialPort1.BytesToRead
            ReDim inBuff(buffLen)

            SerialPort1.Read(inBuff, 0, buffLen)

            rtLog.AppendText("Receive Chars: ")
            For i As Integer = 0 To (buffLen - 1)
                rtLog.AppendText(Chr(inBuff(i)))
            Next

            rtLog.AppendText(", Bytes[dec]:")
            For i As Integer = 0 To (buffLen - 1)
                rtLog.AppendText("[" + Str(Asc(Chr(inBuff(i)))) + "]")
            Next
            rtLog.AppendText(vbCrLf)

            'Set the GUI 
            If (inBuff(0) And 128) = 0 Then cbAsk1.Checked = False Else cbAsk1.Checked = True
            If (inBuff(0) And 64) = 0 Then cbAsk2.Checked = False Else cbAsk2.Checked = True
            If (inBuff(0) And 32) = 0 Then cbAsk3.Checked = False Else cbAsk3.Checked = True
            If (inBuff(0) And 16) = 0 Then cbAsk4.Checked = False Else cbAsk4.Checked = True
            If (inBuff(0) And 8) = 0 Then cbAsk5.Checked = False Else cbAsk5.Checked = True
            If (inBuff(0) And 4) = 0 Then cbAsk6.Checked = False Else cbAsk6.Checked = True
            If (inBuff(0) And 2) = 0 Then cbAsk7.Checked = False Else cbAsk7.Checked = True
            If (inBuff(0) And 1) = 0 Then cbAsk8.Checked = False Else cbAsk8.Checked = True

            If (inBuff(1) And 128) = 0 Then cbAsk9.Checked = False Else cbAsk9.Checked = True
            If (inBuff(1) And 64) = 0 Then cbAsk10.Checked = False Else cbAsk10.Checked = True
            If (inBuff(1) And 32) = 0 Then cbAsk11.Checked = False Else cbAsk11.Checked = True
            If (inBuff(1) And 16) = 0 Then cbAsk12.Checked = False Else cbAsk12.Checked = True
            If (inBuff(1) And 8) = 0 Then cbAsk13.Checked = False Else cbAsk13.Checked = True
            If (inBuff(1) And 4) = 0 Then cbAsk14.Checked = False Else cbAsk14.Checked = True
            If (inBuff(1) And 2) = 0 Then cbAsk15.Checked = False Else cbAsk15.Checked = True
            If (inBuff(1) And 1) = 0 Then cbAsk16.Checked = False Else cbAsk16.Checked = True

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        SetSingleRelay("01", "+")
    End Sub

    Private Sub Button20_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button20.Click
        Try
            SerialPort1.Close()
            rtLog.AppendText("Com Port closed" + vbCrLf)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub


    Private Sub Button23_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button23.Click
        rtLog.Clear()
    End Sub


    Private Sub Button17_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button17.Click
        SetAllOnOff("on")
    End Sub

    Private Sub Button18_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button18.Click
        SetAllOnOff("off")
    End Sub

    Private Sub Button19_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button19.Click
        Try
            SerialPort1.PortName = tfComName.Text
            SerialPort1.BaudRate = Val(tfComBaud.Text)
            SerialPort1.Open()
            rtLog.AppendText("Com Port opened" + vbCrLf)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try


    End Sub



    Private Sub cbSetRelay1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbSetRelay1.CheckedChanged
        SetSingleRelay("01", cbSetRelay1.Checked)
    End Sub

    Private Sub cbSetRelay2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbSetRelay2.CheckedChanged
        SetSingleRelay("02", cbSetRelay2.Checked)
    End Sub

    Private Sub cbSetRelay3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbSetRelay3.CheckedChanged
        SetSingleRelay("03", cbSetRelay3.Checked)
    End Sub

    Private Sub cbSetRelay4_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbSetRelay4.CheckedChanged
        SetSingleRelay("04", cbSetRelay4.Checked)
    End Sub

    Private Sub cbSetRelay5_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbSetRelay5.CheckedChanged
        SetSingleRelay("05", cbSetRelay5.Checked)
    End Sub

    Private Sub cbSetRelay6_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbSetRelay6.CheckedChanged
        SetSingleRelay("06", cbSetRelay6.Checked)
    End Sub

    Private Sub cbSetRelay7_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbSetRelay7.CheckedChanged
        SetSingleRelay("07", cbSetRelay7.Checked)
    End Sub

    Private Sub cbSetRelay8_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbSetRelay8.CheckedChanged
        SetSingleRelay("08", cbSetRelay8.Checked)
    End Sub

    Private Sub cbSetRelay9_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbSetRelay9.CheckedChanged
        SetSingleRelay("09", cbSetRelay9.Checked)
    End Sub

    Private Sub cbSetRelay10_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbSetRelay10.CheckedChanged
        SetSingleRelay("10", cbSetRelay10.Checked)
    End Sub

    Private Sub cbSetRelay11_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbSetRelay11.CheckedChanged
        SetSingleRelay("11", cbSetRelay11.Checked)
    End Sub

    Private Sub cbSetRelay12_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbSetRelay12.CheckedChanged
        SetSingleRelay("12", cbSetRelay12.Checked)
    End Sub

    Private Sub cbSetRelay13_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbSetRelay13.CheckedChanged
        SetSingleRelay("13", cbSetRelay13.Checked)
    End Sub

    Private Sub cbSetRelay14_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbSetRelay14.CheckedChanged
        SetSingleRelay("14", cbSetRelay14.Checked)
    End Sub

    Private Sub cbSetRelay15_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbSetRelay15.CheckedChanged
        SetSingleRelay("15", cbSetRelay15.Checked)
    End Sub

    Private Sub cbSetRelay16_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbSetRelay16.CheckedChanged
        SetSingleRelay("16", cbSetRelay16.Checked)
    End Sub


    Private Sub Button21_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button21.Click
        SetAllRelays()
    End Sub




    Private Sub Button22_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button22.Click
        GetAllRelays()
    End Sub

End Class

